<template>
  <GenericLayout class-names="bg-primary">
    <template #page-content>
      <div
        class="full-height column padding-top-ios"
      >
        <q-card
          flat
          class="bg-transparent column no-wrap col"
        >
          <q-card-section
            class="column flex-center q-gutter-y-md"
          >
            <img
              src="/images/logo/fast-farmer-app.svg"
              alt="FaST logo"
              style="height: 120px; display: block; max-width: 100%;"
              class="q-mb-sm q-mt-lg"
            >

            <div class="text-h4 text-white q-mb-none">
              FaST
            </div>

            <div style="height: 1px; width: 100%; background-color: white;" />

            <div
              v-if="loading"
              class="column flex-center text-grey"
            >
              <q-spinner
                v-if="retrying"
                color="white"
                size="40px"
              />
              <div
                v-if="loadingError"
                class="q-mb-none column items-center"
              >
                <div class="text-h6 text-white">
                  <translate>Something went wrong. Please try again later.</translate>
                </div>
                <q-btn
                  color="white"
                  outline
                  @click="loadCountriesAndRegions"
                  class="q-mt-md"
                >
                  <translate>Retry</translate>
                </q-btn>
              </div>
            </div>
            <CountriesAndRegionsSelection
              v-else-if="countries"
              :countries="countries"
              :selected-country="selectedCountry"
              :selected-region="selectedRegion"
              @select-country="onSelectCountry"
              @select-region="onSelectRegion"
            />
          </q-card-section>

          <q-card-actions
            v-if="showLoginButton"
            vertical
            align="stretch"
            :class="{ 'q-mt-auto': !isDesktopPlatform }"
          >
            <!-- login button with language selection dropdown -->
            <q-btn-dropdown
              v-if="showLanguageSelect"
              split
              :label="$gettext('Login')"
              :disable="!selectedRegionOrCountry"
              size="lg"
              color="white"
              text-color="dark"
              dropdown-icon="las la-language"
              class="login-button"
              @click="onClickLogin"
            >
              <q-list>
                <q-item
                  v-for="language in selectableLanguages"
                  :key="language.languageCode"
                  clickable
                  v-close-popup
                  @click="onClickLanguage(language.languageCode)"
                >
                  <q-item-section>
                    <q-item-label>
                      {{ language.name }}
                    </q-item-label>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-btn-dropdown>

            <!-- standard login button -->
            <q-btn
              v-else
              :label="$gettext('Login')"
              :disable="!selectedRegionOrCountry"
              size="lg"
              color="white"
              text-color="dark"
              @click="onClickLogin"
            />
          </q-card-actions>
        </q-card>

        <div class="row q-mt-auto justify-end">
          <div
            v-if="appVersion"
            class="text-small text-white q-mr-md q-mt-md"
          >
            {{ appVersion }}
          </div>
        </div>
      </div>
    </template>
  </GenericLayout>
</template>

<script>
import GenericLayout from 'src/layouts/GenericLayout'
import CountriesAndRegionsSelection from 'src/pages/login/region-selection/components/CountriesAndRegionsSelection'
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { LanguageMixin } from 'src/mixins/LanguageMixin'
import { loadTopLevelConfig, getCountriesAndRegionsConfig, setRegionConfig } from 'src/services/region-config'
import { AVAILABLE_LANGUAGES, parseLanguageConfig } from 'src/services/translate'

export default {
  name: 'RegionSelection',
  mixins: [
    PlatformMixin,
    LanguageMixin
  ],
  components: {
    GenericLayout,
    CountriesAndRegionsSelection
  },
  data () {
    return {
      loading: true,
      loadingError: false,
      retrying: false,
      countries: null,
      selectedCountry: null,
      selectedRegion: null,
      selectedLanguage: null
    }
  },
  computed: {
    selectedRegionOrCountry () {
      if (this.selectedRegion) {
        return this.selectedRegion
      } else if (this.selectedCountry?.region_id) {
        return this.selectedCountry
      }
      return null
    },
    showLoginButton () {
      return !this.loading && this.countries && this.selectedRegionOrCountry
    },
    appVersion () {
      const version = process.env.APP_VERSION || ''
      return version ? (version.startsWith('v') ? version : `v${version}`) : ''
    },
    availableLanguageCodes () {
      if (!this.selectedCountry) {
        return []
      } else {
        return parseLanguageConfig(this.selectedCountry.language_codes)
      }
    },
    selectableLanguages () {
      return this.availableLanguageCodes.map(languageCode => AVAILABLE_LANGUAGES[languageCode]).filter(Boolean)
    },
    defaultLanguageCode () {
      return this.availableLanguageCodes[0]
    },
    showLanguageSelect () {
      return this.selectableLanguages?.length > 1 && this.selectedLanguage
    }
  },
  methods: {
    onSelectCountry (country) {
      this.selectedCountry = country

      // autoselect region if possible
      if (this.selectedCountry.regions?.length === 1) {
        this.selectedRegion = this.selectedCountry.regions[0]
      } else {
        this.selectedRegion = null
      }

      // Update the current language
      this.setCurrentLanguage(this.defaultLanguageCode)
    },
    onSelectRegion (region) {
      this.selectedRegion = region
    },
    onClickLogin () {
      this.loading = true
      setRegionConfig(this.selectedRegionOrCountry, this.availableLanguageCodes, this.isMobileApp).then(() => {
        this.$router.push({ name: 'login' })
      }).catch(() => {
        this.loadingError = true
      })
    },
    onClickLanguage (languageCode) {
      this.setCurrentLanguage(languageCode)
    },
    setCurrentLanguage (languageCode) {
      if (languageCode && Object.keys(AVAILABLE_LANGUAGES).includes(languageCode)) {
        this.selectedLanguage = languageCode
        this.setPlatformLanguage(languageCode)
      }
    },
    async getCountriesAndRegionsWithRetry (topLevelConfig, maxAttempts, sleepDuration, attempt = 0) {
      try {
        const countriesAndRegions = await getCountriesAndRegionsConfig(topLevelConfig)
        this.loading = false
        this.loadingError = false
        this.retrying = false
        this.countries = countriesAndRegions
        if (countriesAndRegions?.length === 1) {
          const autoSelectedCountry = countriesAndRegions[0]
          this.onSelectCountry(autoSelectedCountry)
          if (autoSelectedCountry.regions?.length === 1) {
            const autoSelectedRegion = autoSelectedCountry.regions[0]
            this.onSelectRegion(autoSelectedRegion)
          }
        }
      } catch (e) {
        if (attempt < maxAttempts) {
          console.log('getCountriesAndRegions failed, retrying (attempt=' + attempt + ')')
          this.retrying = true
          await new Promise(resolve => setTimeout(resolve, sleepDuration))
          this.getCountriesAndRegionsWithRetry(topLevelConfig, maxAttempts, sleepDuration, attempt + 1)
        } else {
          this.loadingError = true
          this.retrying = false
        }
      }
    },
    async loadCountriesAndRegions () {
      this.loading = true
      this.loadingError = false
      this.retrying = false

      try {
        // Load the top level config
        const topLevelConfig = await loadTopLevelConfig()

        // get the countries and regions configuration file
        await this.getCountriesAndRegionsWithRetry(topLevelConfig, 3, 5000)
      } catch (e) {
        console.error('Failed to load countries and regions configuration', e)
        this.loadingError = true
      }
    }
  },
  mounted () {
    this.loadCountriesAndRegions()
  }
}
</script>

<style scoped>
.login-button:deep(.q-btn-dropdown__arrow-container) {
  max-width: 52px;
}
</style>
